checkModisRepos<-function(TLUT,year,doyuse) {
 #function to check MODIS repository for available days with downloaded data

  intervals <- doyuse-year*1000

  # generate list of needed files
  neededFiles <- array(dim=c(length(TLUT)/6,length(intervals)))
  for (i in 1:(length(TLUT)/6)) {

   if ((length(TLUT)/6)==1) {
    if (TLUT[1]<10) H <- paste("0",TLUT[1],sep="") else H <- TLUT[1]
    if (TLUT[2]<10) V <- paste("0",TLUT[2],sep="") else V <- TLUT[2]
   } else {
    if (TLUT[i,1]<10) H <- paste("0",TLUT[i,1],sep="") else H <- TLUT[i,1]
    if (TLUT[i,2]<10) V <- paste("0",TLUT[i,2],sep="") else V <- TLUT[i,2]
   }

   for (j in 1:length(intervals)) {
    day <- intervals[j]
    if (day<10)       DAY <- paste("00",day,sep="")
    else if (day<100) DAY <- paste("0",day,sep="")
    else              DAY <- day    
    neededFiles[i,j]      <- paste("MOD09A1.A",year,DAY,".h",H,"v",V,".",modis_ver,sep="")
   }
  }

 availFiles<-neededFiles

  # check if files are in modisrep
 for (i in 1:dim(availFiles)[1]) {
  for (j in 1:dim(availFiles)[2]) {
   if (length(list.files(path=paste(modisrep,year,sep="/"),pattern=availFiles[i,j]))>0)next
   if (length(list.files(path=paste(modisrep,year,sep="/"),pattern=availFiles[i,j]))==0)availFiles[i,j]<-NA
  }
 }
 #check last available date
 availDays<-matrix(as.numeric(substring(availFiles,nchar("MOD09A1.A20170"),nchar("MOD09A1.A2017001"))),nrow=nrow(availFiles),ncol=ncol(availFiles))
 return(max(availDays,na.rm=T))
}
