# function for parsing the namelist file
extractfrom.config<-function(item){
 # read the file
 config<-scan(file=paste(scriptpath,"/namelist",sep=""),what="",sep="\n")
 # strip off white spaces
 config<-gsub(" ","",config)
 # ignore lines without assignment
 config<-config[grep("=",config)]
 # ignore commented out lines
 config<-config[which(substr(config,1,1)!="#")]
 # get the right line
 tmp<-config[grep(item,config)]
 # get the last entry (in case of double declaration)
 tmp<-tmp[length(tmp)]
 # check if value was found
 if (length(tmp)==0) {
  stop(paste("Error: '",item,"' was not specified in namelist.",sep=""))
 }
 # get the right value and tranform to numbers
 tmp<-strsplit(tmp,split="=")[[1]][2]
 csv<-strsplit(tmp,split=",")
 options(warn=-1)
 if (length(csv[[1]])>1) {
  num<-as.numeric(csv[[1]])
  options(warn=0)
  if (is.na(min(num))) return(csv[[1]])
  else return(num)
 }
 else {
  num<-as.numeric(tmp)
  options(warn=0)
  if (!is.na(num)) return(num)
  else return(tmp)
 }
}

