#get LSWI and EVI, use code from viewModis.hdf : now 20.05.2010
hdf.read<-function(filename,variable="evi") {
  h5 <- H5File(filename)
  scalefactor <- 10000.0
  edat <- getH5Dataset(getH5Group(getH5Group(h5, "SAMPLE_L3_GRID"), "Data Fields"), paste(variable,"_avg",sep=""))
  edat<-matrix(readH5Data(edat),ncol=ncol(edat),nrow=nrow(edat),byrow=T)
  if(variable=="evi"){
    edat[edat> scalefactor]<-NA #exclude outside of [0,1]  
    edat[edat<0]<-NA #exclude outside of [0,1]
  } else if(variable=="lswi"){  
    edat[edat>scalefactor]<-NA #exclude outside of [-1,1] 
    edat[edat< -scalefactor]<-NA #exclude outside of [-1,1] 
  } else if(variable=="ndvi"){
    edat[edat== -28672]<-NA #-28672 is missing value indicator
  } else stop(paste(variable,"not found in hdf5 data",filename)) 
    edat<- edat / scalefactor 
    return(edat[dim(edat)[1]:1,])
}



#Old, before "hdf5" was removed from the CRAN repository
#hdf.read<-function(filename,variable="evi") {
#  hdf5load(filename)
#  scalefactor <- 10000.0
#  if(variable=="evi"){
#    edat<-SAMPLE_L3_GRID$"Data Fields"$"evi_avg"
#    edat[edat> scalefactor]<-NA #exclude outside of [0,1]  
#    edat[edat<0]<-NA #exclude outside of [0,1]
#    } else if(variable=="lswi"){  
#    edat<-SAMPLE_L3_GRID$"Data Fields"$"lswi_avg"
#    edat[edat>scalefactor]<-NA #exclude outside of [-1,1] 
#    edat[edat< -scalefactor]<-NA #exclude outside of [-1,1] 
#    } else if(variable=="ndvi"){
#    edat<-SAMPLE_L3_GRID$"Data Fields"$"ndvi_avg"
#    edat[edat>scalefactor]<-NA #exclude outside of [0,1]
#    edat[edat<0]<-NA #exclude outside of [0,1]
#    } else stop(paste(variable,"not found in hdf5 data",filename)) 
#    rm(SAMPLE_L3_GRID)
#    edat<- edat / scalefactor 
#    return(edat[dim(edat)[1]:1,])
#   }

