month.day.year <- function (jul, origin.)
{
    if (missing(origin.) || is.null(origin.))
        if (is.null(origin. <- .Options$chron.origin))
            origin. <- c(month = 1, day = 1, year = 1960)
    if (all(origin. == 0))
        shift <- 0
    else shift <- julian(origin = origin.)
    j <- jul + shift
    j <- j - 1721119
    y <- (4 * j - 1)%/%146097
    j <- 4 * j - 1 - 146097 * y
    d <- j%/%4
    j <- (4 * d + 3)%/%1461
    d <- 4 * d + 3 - 1461 * j
    d <- (d + 4)%/%4
    m <- (5 * d - 3)%/%153
    d <- 5 * d - 3 - 153 * m
    d <- (d + 5)%/%5
    y <- 100 * y + j
    y <- y + ifelse(m < 10, 0, 1)
    m <- m + ifelse(m < 10, 3, -9)
    list(month = m, day = d, year = y)
}

julian <- function (m, d, y, origin.)
{
    only.origin <- all(missing(m), missing(d), missing(y))
    if (only.origin)
        m <- d <- y <- NULL
    nonnumeric.p <- !c(is.numeric(m), is.numeric(d), is.numeric(y))
    if (any(nonnumeric.p) && !only.origin) {
        badarg <- paste(c("m", "d", "y")[nonnumeric.p], collapse = ", ")
        stop(paste("Arguments:", badarg, "are not numeric"))
    }
    if (missing(origin.))
        if (is.null(origin. <- .Options$chron.origin))
            origin. <- c(month = 1, day = 1, year = 1960)
    nms <- names(d)
    max.len <- max(length(m), length(d), length(y))
    m <- c(origin.[1], rep(m, length = max.len))
    d <- c(origin.[2], rep(d, length = max.len))
    y <- c(origin.[3], rep(y, length = max.len))
    y <- y + ifelse(m > 2, 0, -1)
    m <- m + ifelse(m > 2, -3, 9)
    c <- y%/%100
    ya <- y - 100 * c
    out <- (146097 * c)%/%4 + (1461 * ya)%/%4 + (153 * m + 2)%/%5 +
        d + 1721119
    if (!only.origin) {
        if (all(origin. == 0))
            out <- out[-1]
        else out <- out[-1] - out[1]
    }
    names(out) <- nms
    out
}