combineDays <- function(vari,tileids,projinfo,doyuse) {

   # to do: make days used flexible
   pnam <- paste(".ier1km",sep="")

   for (tid in tileids[-1]) {
    if (!newModis&file.exists(paste(datp,"/.RData",vari,".",tid,".",projinfo$year,pnam,sep=""))) {
      print(paste(datp,"/.RData",vari,".",tid,".",projinfo$year,pnam," already there. Skipping.",sep=""))
      next
    }

    days <- doyuse
    first<-TRUE
    for(i in 1:length(days)) {
     if(!file.exists(paste(datp,"/.RData",vari,days[i],".",tid,pnam,sep="")))next
     dat<-getr(paste(vari,days[i],".",tid,pnam,sep=""),datp)
     if(first) {outdat<-array(NA,dim=c(dim(dat),length(days)));first<-FALSE}
     outdat[,,i] <- dat
    }#loop over days

    assignr(paste(vari,".",tid,".",projinfo$year,pnam,sep=""),outdat,datp)
   }
   
}
                                                                                       
readIndicesIntoR<-function(vari="evi",projinfo,doyuse,bugfix=FALSE) {
  if (bugfix) browser()
 
  filemask <- paste("_MOD09A1.A",projinfo$year,"*.1km.hdf",sep="") # res km ier projection
  filemask2 <- paste("_MOD09A1N.A",projinfo$year,"*.1km.hdf",sep="") # res km ier projection
  pnam     <- paste(".ier1km",sep="")
  tileids  <- array()

  efiles   <- system(paste("cd ",mpath,";ls ",vari,filemask,sep=""),intern=TRUE)
  efiles2   <- system(paste("cd ",mpath,";ls ",vari,filemask2,sep=""),intern=TRUE)
  days     <- doyuse

  for(i in 1:length(days)) {
   #combine
   day    <- days[i]

   efiled <-efiles[substring(efiles,nchar(paste(vari,"_MOD09A1.A2",sep="")),nchar(paste(vari,"_MOD09A1.A",projinfo$year,"121",sep="")))==day]
   if(length(efiled)==0)efiled <-efiles2[substring(efiles2,nchar(paste(vari,"_MOD09A1N.A2",sep="")),nchar(paste(vari,"_MOD09A1N.A",projinfo$year,"121",sep="")))==day]
   
   #loop over different tiles
   for (File in efiled) {  
    # get tile id and save all different tileids for later use
    tileid <- strsplit(File,split="\\.")[[1]][3]
    # add it only once
    if (length(which(tileids==tileid))==0) tileids <- cbind(tileids,tileid)
    if (file.exists(paste(datp,"/.RData",vari,day,".",tileid,pnam,sep=""))) next
    
    #transform to hdf
    if(file.exists(paste(mpath,"temp.h5",sep="")))system(paste("rm ",mpath,"temp.h5",sep=""),intern=TRUE)  #clean up first
    system(paste("h4toh5 ",mpath,File," ",mpath,"temp.h5",sep=""),intern=TRUE)
    
    #read with R, save as .RData
    edatd <- hdf.read(paste(mpath,"temp.h5",sep=""),vari)
    
    assignr(xname=paste(vari,day,".",tileid,pnam,sep=""),value=edatd,path=datp)
   }
  }#loop over days

 # Combine different files for each 8-day period to one R-object file.
 combineDays(vari,tileids,projinfo,doyuse)

}
