# Script for loess filtering of one MODIS tile, called by submit_loess.sh.
# Purpose is parallel execution on cluster via LSF queueing system.


scriptpath <- getwd() # path of preprocessor
sourcepath <-paste(scriptpath,"/RSources/",sep="")

source(paste(scriptpath,"/RSources/monthdayyear.r",sep=""))

# read configuration
source(paste(scriptpath,"/config.r",sep=""))

ftdata   <- FALSE          # shall we connect to ftp and check for data?
projtype <- "LCC"       # type of projection LCC xor GEO
datp <- rdataout
mdy      <- month.day.year
attachn  <- function(what, pos = 2){if(!(paste("file:",what,sep="")%in%search()))attach(what,pos)}
go       <- graphics.off

# set synmap resolution
spacing <- 1/120

# set number of used vegetation classes
nveg <- 8 

setwd(rdataout)

#library("hdf5")
library("h5r")

source(paste(scriptpath,"/RSources/assignr.r",sep=""))
source(paste(scriptpath,"/RSources/project.nice.r",sep=""))
source(paste(scriptpath,"/RSources/getminmax.r",sep=""))
source(paste(scriptpath,"/RSources/distance.r",sep=""))
source(paste(scriptpath,"/RSources/getr.r",sep=""))
source(paste(scriptpath,"/RSources/loess.r",sep=""))
source(paste(scriptpath,"/RSources/imagell.r",sep=""))
source(paste(scriptpath,"/RSources/na_replace.r",sep=""))
source(paste(scriptpath,"/RSources/combineTiles.r",sep=""))
source(paste(scriptpath,"/RSources/hdfread.r",sep=""))
source(paste(scriptpath,"/RSources/parseNamelist.r",sep=""))
source(paste(scriptpath,"/RSources/getModis.r",sep=""))
source(paste(scriptpath,"/RSources/extractAndReduce.r",sep=""))
source(paste(scriptpath,"/RSources/doResampling.r",sep=""))
source(paste(scriptpath,"/RSources/readIndicesIntoR.r",sep=""))
source(paste(scriptpath,"/RSources/cutToDomain.r",sep=""))
source(paste(scriptpath,"/RSources/doAggregation.r",sep=""))
source(paste(scriptpath,"/RSources/writeOutput.r",sep=""))

# load configuration
projinfo <- getr("projinfo",datp)

# cd to working directory
setwd(mpath)

load("TLUT.RData")
load("doyuse.RData")
fcstmode<-FALSE
if(exists("forecstTF"))if(forecstTF)fcstmode<-TRUE


args <- commandArgs()
print(args)

H    <- args[5]
V    <- args[6]
vari <- args[7]
projs<-paste("h",H,"v",V,".",projinfo$year,".ier1km",sep="")

print(projs)
Smoothevilswi(vari,proj=projs,doyall=doyall,doyuse=doyuse,fcstmode=fcstmode) # defined in loess.r

