#!/bin/bash
# script to start parallel execution of loess filtering on cluster
#
# usage:
# ./submit_getmapping.sh <PATH_TO_PREPROC> <NEST> <LENGTH_OF_LAT_VECTOR>

process_id=$$

job_limit=10 #number of jobs that should run in parallel

dom=$2

# calculate index for each job
lat_length=$3
count=$(($lat_length/$job_limit))
remainder=$(($lat_length%$job_limit))

# calculade sum of needed jobs
needed_jobs=$(($lat_length/$count))
if [[ "$remainder" -ne "0" ]]
then 
needed_jobs=$(($needed_jobs+1))
fi
echo "Needed jobs in submit_getmapping.sh: $needed_jobs"
echo "lat_length: $lat_length"
echo  "count: $count"
echo "remainder: $remainder"

cd $1
echo "Now submtt getmapping.r parallel"

for ((i=1;i<=$(($lat_length/$count));i++))
do

 start_index=$(($(($i-1))*$count+1))

 command="R --no-save --no-readline --args ${dom} ${start_index} ${count} < lsf_getmapping.r >& lsf_getmapping.r.Rout.${i}"
 #bsub -M 8000000 -J getmapping_${process_id} -o lsf_getmapping.r.Rout.${i} -e lsf_getmapping.r.Rout.${i}  -q all -g /rkretsch_group -M 80 ${command}
#bsub -J getmapping_${process_id} -o lsf_getmapping.r.Rout.${i} -e lsf_getmapping.r.Rout.${i}  -q all -g /rkretsch_group -M 8000000 ${command}
bsub -R "rusage[mem=4000]" -J getmapping_${process_id} -o lsf_getmapping.r.Rout.${i} -e lsf_getmapping.r.Rout.${i}  -q all  -M 12000000 ${command}
done
 												
i=$(($lat_length/$count+1))

# submit the remainder
if [[ "$remainder" -ne "0" ]]
then

 start_index=$(($lat_length-$remainder+1))

 command="R --no-save --no-readline --args ${dom} ${start_index} ${remainder} < lsf_getmapping.r >& lsf_getmapping.r.Rout.${i}"
# bsub -J getmapping_${process_id} -o lsf_getmapping.r.Rout.${i} -e lsf_getmapping.r.Rout.${i} -R  -q all -g /rkretsch_group -M 8000000  ${command}
 bsub -R "rusage[mem=4000]" -J getmapping_${process_id} -o lsf_getmapping.r.Rout.${i} -e lsf_getmapping.r.Rout.${i} -q all  -M 12000000  ${command}

fi


# place another job to make sure all the loess jobs have finished when this script ends
#bsub -M 8000000 -w "done(getmapping_${process_id})" -q all -K -g /rkretsch_group sleep 1
command="R --no-save --no-readline --args ${dom} ${start_index} ${remainder} ${needed_jobs}  < lsf_getmapping_wait.r >& lsf_getmapping_wait.r.Rout" # new tk
bsub -w "done(getmapping_${process_id})"  -q all -K -M 1000000 ${command}
