#!/bin/bash
# script to start parallel execution of loess filtering on cluster
#
# usage:
# ./submit_loess <PATH_TO_PREPROC> <"evi" | "lswi" | "evi lswi">

job_limit=20 #maximum number of how many jobs should run in parallel
needed_jobs=0

cd $1

process_id=$$

i=0
j=0
lines=$(cat tiles.txt | wc -l)
for vari in $2
 do
  for file in $(cat tiles.txt)
  do
   let i=$i+1
   let j=$j+1
   let lines=$lines-1

   let needed_jobs=$needed_jobs+1

   if [[ $j -lt $job_limit && $lines -gt 0 ]]
   then 
    tiles=$(echo $file | awk -F , '{print $1,$2}')
    command="R --no-save --no-readline --args ${tiles} ${vari} < process_loess.r >& process_loess.r.Rout.${i}"
    if [[ "$file" == "16,01" || "$file" == "19,01" ]]
    then
      echo "submit loess ${file} to queue io"
      bsub -q io -M 14000000 -F 4000000 -J loess_${process_id} -R "rusage[mem=4000]" -o process_loess.r.Rout.${i} -e process_loess.r.Rout.${i} ${command}
    else
      echo "submit loess ${file} to queue all"
      bsub -q io -M 14000000 -F 4000000 -J loess_${process_id} -R "rusage[mem=4000]" -o process_loess.r.Rout.${i} -e process_loess.r.Rout.${i} ${command}
    fi
    sleep 1
   else
    j=0
    tiles=$(echo $file | awk -F , '{print $1,$2}')
    command="R --no-save --no-readline --args ${tiles} ${vari} < process_loess.r >& process_loess.r.Rout.${i}"
    if [[ "$file" == "16,01" || "$file" == "19,01" ]]
    then
      echo "submit loess ${file} to queue io"
      bsub -q io  -M 14000000 -F 4000000 -J loess_${process_id} -R "rusage[mem=4000]" -o process_loess.r.Rout.${i} -e process_loess.r.Rout.${i} -K ${command}
    else
      echo "submit loess ${file} to queue all"
      bsub -q io -M 14000000 -F 4000000 -J loess_${process_id} -R "rusage[mem=4000]" -o process_loess.r.Rout.${i} -e process_loess.r.Rout.${i} -K ${command}
    fi
    sleep 1
   fi
   
  done
done 

# place another job to make sure all the loess jobs have finished when this script ends
  command="R --no-save --no-readline --args ${tiles} ${vari} ${needed_jobs} < process_loess_wait.r >& process_loess_wait.r.Rout.${i}" # new tk
bsub -M 1000000 -w "done(loess_${process_id})" -q all -K  ${command}
